#include <Adafruit_NeoPixel.h>

#define PIN 6
#define PIXEL_COUNT 57
Adafruit_NeoPixel strip = Adafruit_NeoPixel(57, PIN, NEO_GRB + NEO_KHZ800);

/**
* Знакогенератор для цифр
*/
uint16_t DIGIT[] = {
  0x1FBF, /* 0 */
  0x1F00, /* 1 */
  0x1DF7, /* 2 */
  0x1FF5, /* 3 */
  0x1F5C, /* 4 */ 
  0x17FD, /* 5 */ 
  0x17FF, /* 6 */ 
  0x1F30, /* 7 */ 
  0x1FFF, /* 8 */ 
  0x1FFD  /* 9 */ 
  
};

/**
* Смещение для каждой цифры
*/
uint8_t POSITION[] = { 0,14,30,44 };



unsigned int R_MASK[] = { 0x0001, 0x0002, 0x0004, 0x0008, 0x0010, 0x0020, 0x0040, 0x0080, 0x0100, 0x0200, 0x0400, 0x0800, 0x1000 };  
  
  

// Буфер экрана
uint32_t SB[PIXEL_COUNT];

/*
* Очистка буфера обмена
*/
void Clear(){
   for( int i=0; i<PIXEL_COUNT; i++ )SB[i] = 0;
}  

/**
* Запись одного сивола в буфер
*@param c - сивол ( '0' - '9' ) 
*@param digit - разряд digit ( 0-4 )
*@param color - цвет и яркость
*/
void PutChar(char c,uint8_t digit,uint32_t color){
    if( digit < 0 || digit > 3 )return;
    uint16_t mask = 0;
    switch(c){
      case '0': mask = DIGIT[0]; break;
      case '1': mask = DIGIT[1]; break;
      case '2': mask = DIGIT[2]; break;
      case '3': mask = DIGIT[3]; break;
      case '4': mask = DIGIT[4]; break;
      case '5': mask = DIGIT[5]; break;
      case '6': mask = DIGIT[6]; break;
      case '7': mask = DIGIT[7]; break;
      case '8': mask = DIGIT[8]; break;
      case '9': mask = DIGIT[9]; break;
      default : mask = 0;
    }
    for( int i=0; i<13; i++ )
       if( mask & R_MASK[i] )SB[POSITION[digit]+i] = color;
       else SB[POSITION[digit]+i] = 0;
}  


/**
* Запись одного сивола в буфер
*@param c - сивол ( '0' - '9' ) 
*@param digit - разряд digit ( 0-4 )
*@param color - цвет и яркость
*/
void PutChar2(char c,uint8_t digit,uint32_t color){
    if( digit < 0 || digit > 3 )return;
    uint16_t mask = 0;
    switch(c){
      case '0': mask = DIGIT[0]; break;
      case '1': mask = DIGIT[1]; break;
      case '2': mask = DIGIT[2]; break;
      case '3': mask = DIGIT[3]; break;
      case '4': mask = DIGIT[4]; break;
      case '5': mask = DIGIT[5]; break;
      case '6': mask = DIGIT[6]; break;
      case '7': mask = DIGIT[7]; break;
      case '8': mask = DIGIT[8]; break;
      case '9': mask = DIGIT[9]; break;
      default : mask = 0;
    }
    for( int i=0; i<13; i++ )
       if( mask & R_MASK[i] )SB[POSITION[digit]+i] = SB[POSITION[digit]+i]+color;
}  


/**
* Отображение буфера на дисплее
*/
void Refresh(){
   for( int i=0; i<PIXEL_COUNT; i++ )strip.setPixelColor(i,SB[i]);
   strip.show(); // Initialize all pixels to 'off'
}







void setup() {
  strip.begin();
  strip.show(); // Initialize all pixels to 'off'
  Clear();
  PutChar('2',0,strip.Color(255, 0, 0));
  PutChar('0',1,strip.Color(255, 0, 0));
  PutChar('1',2,strip.Color(255, 0, 0));
  PutChar('5',3,strip.Color(255, 0, 0));
  Refresh();
}

uint32_t l0 = 0, l1 = 0, l2 = 0,l3=0;
uint32_t c1 = 0;
boolean flag = false,flag1 = true;
uint8_t mode = 0;
uint8_t xx   = 0;


   int i1 = 55, i2=128, i3=192, i4=255;

void loop() {
 
  for( int i=0; i<128; i++ ){
      uint32_t c1 = strip.Color(i, 0, 0);
      PutChar('2',0,c1);
      PutChar('0',1,c1);
      PutChar('1',2,c1);
      PutChar('5',3,c1);
      Refresh();
      delay(20);
   }  
   for( int i=128; i>=0;i--  ){
      uint32_t c1 = strip.Color(i, 0, 0);
      PutChar('2',0,c1);
      PutChar('0',1,c1);
      PutChar('1',2,c1);
      PutChar('5',3,c1);
      Refresh();
      delay(20);
   }  
  for( int i=0; i<128; i++ ){
      uint32_t c1 = strip.Color(0, i, 0);
      PutChar('2',0,c1);
      PutChar('0',1,c1);
      PutChar('1',2,c1);
      PutChar('5',3,c1);
      Refresh();
      delay(20);
   }  
   for( int i=128; i>=0;i--  ){
      uint32_t c1 = strip.Color(0, i, 0);
      PutChar('2',0,c1);
      PutChar('0',1,c1);
      PutChar('1',2,c1);
      PutChar('5',3,c1);
      Refresh();
      delay(20);
   }  
  for( int i=0; i<128; i++ ){
      uint32_t c1 = strip.Color(0, 0, i);
      PutChar('2',0,c1);
      PutChar('0',1,c1);
      PutChar('1',2,c1);
      PutChar('5',3,c1);
      Refresh();
      delay(20);
   }  
   for( int i=128; i>=0;i--  ){
      uint32_t c1 = strip.Color(0, 0, i);
      PutChar('2',0,c1);
      PutChar('0',1,c1);
      PutChar('1',2,c1);
      PutChar('5',3,c1);
      Refresh();
      delay(20);
   }  

  i1=96; i2=64; i3=32; i4=0;
  for( int i=0; i<256; i++ ){
      i1++; i2++;i3++;i4++;
      if( i1>=128)i1=0;
      if( i2>=128)i2=0;
      if( i3>=128)i3=0;
      if( i4>=128)i4=0;
      PutChar('2',0,strip.Color(i1, 0, 0));
      PutChar('0',1,strip.Color(i2, 0, 0));
      PutChar('1',2,strip.Color(i3, 0, 0));
      PutChar('5',3,strip.Color(i4, 0, 0));
      Refresh();
      delay(20);
   }  
  i1=96; i2=64; i3=32; i4=0;
  for( int i=0; i<256; i++ ){
      i1++; i2++;i3++;i4++;
      if( i1>=128)i1=0;
      if( i2>=128)i2=0;
      if( i3>=128)i3=0;
      if( i4>=128)i4=0;
      PutChar('2',0,strip.Color(0, i1, 0));
      PutChar('0',1,strip.Color(0, i2, 0));
      PutChar('1',2,strip.Color(0, i3, 0));
      PutChar('5',3,strip.Color(0, i4, 0));
      Refresh();
      delay(20);
   }  
  i1=96; i2=64; i3=32; i4=0;
  for( int i=0; i<256; i++ ){
      i1++; i2++;i3++;i4++;
      if( i1>=128)i1=0;
      if( i2>=128)i2=0;
      if( i3>=128)i3=0;
      if( i4>=128)i4=0;
      PutChar('2',0,strip.Color(0, 0, i1));
      PutChar('0',1,strip.Color(0, 0, i2));
      PutChar('1',2,strip.Color(0, 0, i3));
      PutChar('5',3,strip.Color(0, 0, i4));
      Refresh();
      delay(20);
   }  


}

